Redmine - Feature #20388

Removing attachment after commit transaction
2015-07-22 11:083 - lvan Zabrovskiy

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Attachments Estimated time: 0.00 hour
Target version: 3.2.0

Resolution: Fixed

Description

Now in Attachment model is

after_destroy :delete_from_disk

If you want to construct a serious logic with Rollback this behaviour leads to remove file from disk, but leave an attachment record in

DB.
In my project | replaced this callback on

after_commit :delete_from_disk, on: :destroy

and it works perfect.

| think this is a good modification for Redmine. It have full backward compatibility but can extend ability for strong logic in app.

Associated revisions

Revision 14630 - 2015-09-30 20:59 - Jean-Philippe Lang

Remove attachment after transaction commit (#20388).

Patch by Ivan Zabrovskiy.

History

#1 - 2015-07-22 12:52 - Toshi MARUYAMA

- Target version set to 3.2.0

#2 - 2015-08-13 09:28 - lvan Zabrovskiy

Notice: in Rails 4 appear new config option related with transaction callbacks:

config.active_record.raise_in_transactional_callbacks = true
It allows to propagate errors from transaction callbacks. Preferable to turn it on.
#3 - 2015-09-30 21:00 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Change committed in r14630, thanks.
